//Modified by Anand
//dated on 5 june2021

#include <ThingSpeak.h>
#include <SPI.h>
#include <WiFi.h>
#include <WiFiClient.h>
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>
#include <BH1750.h>
#include <LiquidCrystal_I2C.h>

#define SEALEVELPRESSURE_HPA (1013.25)

Adafruit_BME280 bme;
BH1750 lightMeter;
LiquidCrystal_I2C lcd(0x3F,16,2);  // set the LCD address to 0x27 for a 16 chars and 2 line display
// Data wire is plugged into port 2 on the Arduino
const char* ssid = "Workshop"; // replace MySSID with your WiFi network name
const char* password = "VIGYAN0030"; // replace MyPass word with your WiFi password

#define SECRET_CH_ID 1399588                   // replace 0000000 with your channel number
#define SECRET_WRITE_APIKEY "RL5XCYRB4ITPM9PH" // replace XYZ with your channel write API Key

WiFiClient client;

 // your network password
int keyIndex = 0;          // your network key Index number (needed only for WEP)

unsigned long myChannelNumber = SECRET_CH_ID;
const char *myWriteAPIKey = SECRET_WRITE_APIKEY;



void setup()
{
 Serial.begin(9600); //Initialize serial

 WiFi.begin(ssid,password);
 ThingSpeak.begin(client); // Initialize ThingSpeak
 delay(1000);
pinMode(32,OUTPUT);
  pinMode(33,OUTPUT);
  
  Wire.begin();

  
  lightMeter.begin(BH1750::CONTINUOUS_HIGH_RES_MODE, 0x23, &Wire);
  lcd.begin(); 
  Serial.println(F("BH1750 Test"));
  if (!bme.begin(0x76)) {
    Serial.println("Could not find a valid BME280 sensor, check wiring!");
    while (1);
  }
}

void loop()
{
  Serial.print("Temperature = ");
  Serial.print(bme.readTemperature());
  int t =bme.readTemperature();
  Serial.println("*C");
   lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("t=");
  lcd.print(bme.readTemperature());
  lcd.print("C");

  //Serial.print("Pressure = ");
  //Serial.print(bme.readPressure() / 100.0F);
 // Serial.println("hPa");

  Serial.print("Humidity = ");
  Serial.print(bme.readHumidity());
  int h =bme.readHumidity();
  Serial.println("%");
  lcd.setCursor(8,0);
  lcd.print("H=");
  lcd.print(bme.readHumidity());
  lcd.print("%");
  int l = lightMeter.readLightLevel();
   Serial.print("Light: ");
   Serial.print(l);
   Serial.println(" lx");
     lcd.setCursor(0,1);
  lcd.print("L=");
  lcd.print(l);
  lcd.print("lx");

  delay(1000);

if (t>25)

{
  digitalWrite(33,HIGH);
}
else 
{
  digitalWrite(33,LOW);
}

if(h<70)

{
  digitalWrite(32,HIGH);
  //digitalWrite(33,HIGH);
 
}
else 
{
  digitalWrite(32,LOW);
  //digitalWrite(33,LOW);
}
  
// Serial.print("Requesting temperatures...");

  ThingSpeak.writeField(myChannelNumber,1,t, myWriteAPIKey);

 // Serial.print("Requesting humidity...");
 
  ThingSpeak.writeField(myChannelNumber,2,h, myWriteAPIKey);

 // Serial.print("Requesting light...");
 
 ThingSpeak.writeField(myChannelNumber,3,l, myWriteAPIKey);

}
